//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "jpeg.hpp"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   Panel1->DoubleBuffered=true;
   Image1->Width=800;
   Image1->Height=600;
   Image1->Left=(Panel1->Width-Image1->Width)/2;
   Image1->Top=(Panel1->Height-Image1->Height)/2;
   Image1->Canvas->Brush->Color=clWhite;
   Image1->Canvas->FillRect(Rect(0, 0, Image1->Width, Image1->Height));
   Image1->Stretch=true;

   IdTCPServer1->DefaultPort=4000;
   IdTCPServer1->Active=true;
}
__fastcall TForm1::~TForm1()
{
   IdTCPServer1->Active=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IdTCPServer1Execute(TIdPeerThread *AThread)
{
   AnsiString szCommand=AThread->Connection->ReadLn();
   if(szCommand=="ServerToClient")
   {
      Graphics::TBitmap *bmp1=new Graphics::TBitmap;
      TMemoryStream *ms1=new TMemoryStream;
      try
      {
         CURSORINFO ci;
         ci.cbSize=sizeof(CURSORINFO);
         GetCursorInfo(&ci);
         POINT pt;
         GetCursorPos(&pt);

         ms1->Size=0;
         HDC dc;
         TCanvas *cs=new TCanvas;
         dc=GetDC(0);
         cs->Handle=dc;
         bmp1->Width=Screen->Width;
         bmp1->Height=Screen->Height;
         bmp1->Canvas->CopyRect(Rect(0, 0, bmp1->Width, bmp1->Height), cs,
            Rect(0, 0, Screen->Width, Screen->Height));

         DrawIcon(bmp1->Canvas->Handle, pt.x, pt.y, ci.hCursor);

         TJPEGImage *jpg=new TJPEGImage;
         jpg->Assign(bmp1);
         jpg->CompressionQuality=20;
         jpg->Compress();
         jpg->SaveToStream(ms1);

         delete jpg;
         delete cs;
         ReleaseDC(NULL, dc);

         AThread->Connection->WriteStream(ms1, true, true, 0);
      }
      __finally
      {
         delete ms1;
         delete bmp1;
      }
   }
   else if(szCommand=="ClientToServer")
   {
      TMemoryStream *ms1=new TMemoryStream;
      try
      {
         AThread->Connection->ReadStream(ms1, -1, false);

         ms1->Position=0;
         TJPEGImage *jpg=new TJPEGImage;
         jpg->LoadFromStream(ms1);
         jpg->CompressionQuality=100;
         Image1->Picture->Assign(jpg);
         delete jpg;
      }
      __finally
      {
         delete ms1;
      }
   }
   else if(szCommand=="Stop")
   {
      Image1->Picture=NULL;
      Image1->Canvas->Brush->Color=clWhite;
      Image1->Canvas->FillRect(Rect(0, 0, Image1->Width, Image1->Height));
   }
}
//---------------------------------------------------------------------------

